﻿Public Class Hotkey

#Region "Declarations - WinAPI, Hotkey constant and Modifier Enum"
    ''' <summary>
    ''' Declaration of winAPI function wrappers. The winAPI functions are used to register / unregister a hotkey
    ''' </summary>
    Public Declare Function RegisterHotKey Lib "user32" _
    (ByVal hwnd As IntPtr, ByVal id As Integer, ByVal fsModifiers As Integer, ByVal vk As Integer) As Integer

    Public Declare Function UnregisterHotKey Lib "user32" (ByVal hwnd As IntPtr, ByVal id As Integer) As Integer

    Public Const WM_HOTKEY As Integer = &H312

    Enum KeyModifier
        None = 0
        Alt = &H1
        Control = &H2
        Shift = &H4
        Winkey = &H8
    End Enum 'This enum is just to make it easier to call the registerHotKey function: The modifier integer codes are replaced by a friendly "Alt","Shift" etc.
#End Region

#Region "Hotkey registration, unregistration and handling"
    'Public Shared Sub registerHotkey(ByRef sourceForm As Form, ByVal triggerKey As String, ByVal modifier As KeyModifier)
    '    RegisterHotKey(sourceForm.Handle, 1, modifier, Asc(triggerKey.ToUpper))
    'End Sub
    Public Shared Sub registerHotkey(ByRef sourceForm As Form, ByVal hotkeyID As Integer, ByVal triggerKey As String, ByVal modifier As KeyModifier)
        RegisterHotKey(sourceForm.Handle, hotkeyID, modifier, Asc(triggerKey.ToUpper))
    End Sub


    'Public Shared Sub unregisterHotkeys(ByRef sourceForm As Form)
    '    UnregisterHotKey(sourceForm.Handle, 1)  'Remember to call unregisterHotkeys() when closing your application.
    'End Sub

    Public Shared Sub unregisterHotkeys(ByRef sourceForm As Form)
        UnregisterHotKey(sourceForm.Handle, 1)  'Remember to call unregisterHotkeys() when closing your application.
        UnregisterHotKey(sourceForm.Handle, 2)
        UnregisterHotKey(sourceForm.Handle, 3)
        UnregisterHotKey(sourceForm.Handle, 4)
        UnregisterHotKey(sourceForm.Handle, 5)
        UnregisterHotKey(sourceForm.Handle, 6)
        UnregisterHotKey(sourceForm.Handle, 7)
        UnregisterHotKey(sourceForm.Handle, 8)
    End Sub

    'Public Shared Sub handleHotKeyEvent(ByVal hotkeyID As IntPtr)
    '    MsgBox("The hotkey was pressed")
    'End Sub
    Public Shared Sub handleHotKeyEvent(ByVal hotkeyID As IntPtr)
        Select Case hotkeyID
            Case 1
                ' MsgBox("The hotkey ALT+F (ID: 1) was pressed")
                Form1.SaveAsFavorite()
            Case 2
                ' MsgBox("The hotkey ALT+S (ID: 2) was pressed")
                Action = "Stop"
                Call Form1.PlayStop()
            Case 3
                'MsgBox("The hotkey ALT+P (ID: 3) was pressed")
                Action = "Play"
                Call Form1.PlayStop()
            Case 4
                ' MsgBox("The hotkey ALT+S (ID: 2) was pressed")

                Call Form1.PopUpTittle()
            Case 5
                Form1.Close()
                Form2.Close()
                Form3.Close()
                Form5.Close()
                Form6.Close()
                FrmHelp.Close()
            Case 6
                Form1.TimerCloseInTen.Enabled = False
                Form1.TimerClose.Enabled = False

            Case 7
                Form1.OpenPlaylistpstToolStripMenuItem.PerformClick()

            Case 8
                Call Form1.Mute()

        End Select
    End Sub

#End Region

End Class

